-- ************************************************
-- * Program:         Pix-a-Sketch                *
-- * Author:          Greg Phillips               *
-- *                  i.shoot@rednecks.com        *
-- * Start date:      Feb. 5, 1999                *
-- *                                              *
-- * Description:     Simple program that copies  *
-- *                  that neat old Etch-A-Sketch *
-- *                  toy I loved so much.        *
-- ************************************************

include graphics.e
include get.e
include image.e


sequence xy
atom key
integer save
object ask


procedure help()
-- Yer basic help thingy
puts(1, "Controls are simple: use the cursors to move in different directions\n")
puts(1, "'q' quits the program\n")
puts(1, "The enter key erases the screen, just like the Etch-A-Sketch toy")
while wait_key() = 0 do
end while
end procedure

procedure setup()

-- clear the screen
clear_screen()

-- set graphics mode to 18, 640x480, 16 colors
if graphics_mode(18) then
  puts(1, "Can't use current gfx mode")
  abort(1)
end if

-- set up display  (red background, gray drawing area, 2 circles)
polygon(RED, 1,{{1,1}, {1,480}, {640,480},{640,1},{1,1}})
polygon(WHITE, 1,{{20,60}, {20,400}, {620,400},{620,60},{20,60}})
ellipse(BRIGHT_WHITE, 1, {10,470}, {65, 415})
ellipse(BRIGHT_WHITE, 1, {570,470}, {630, 415})

-- find middle of drawing screen
-- the 460 is not an error, it's to find the middle of the gray area
xy = {640/2,460/2}

end procedure

function move()
-- set up movement of line
-- while everything is true, continue, if not, exit loop
  -- get keyboard input
  key = get_key()
    -- check for key pressed, and also make sure pixel is in boundaries
    if key = 331 and xy[1] > 21 then
      xy[1] = xy[1] - 1
    elsif key = 333 and xy[1] < 619 then
      xy[1] = xy[1] + 1
    elsif key = 328 and xy[2] > 61 then
      xy[2] = xy[2] - 1
    elsif key = 336 and xy[2] < 399 then
      xy[2] = xy[2] + 1
    elsif key = 'q' then
      return 0
    -- if enter is pressed, redraw the gray area
    elsif key = 13 then
      polygon(WHITE, 1,{{20,60}, {20,400}, {620,400},{620,60},{20,60}})
    end if
  pixel(BLACK, {xy[1],xy[2]})
  return 1
end function

procedure sav()
-- saving procedure
puts(1, "Would you like to save image? [y/n] ")
ask = wait_key()
  if ask = 'y' then
    puts(1, "\nWhat would you like to save it as? [Do not add .bmp extention] ")
    ask = gets(0)
    ask = ask[1..length(ask)-1]
    -- save drawing (grey) area to disk, in current directory, as a bitmap
    -- the save proc needs work, this whole thing does
    -- I just threw this in here so I could show off my beautiful
    -- picture of a blob..err...flower =)
      save = save_screen({{20,60},{620,400}}, ask & ".bmp")
  elsif ask = 'n' then
    puts(1, "Goodbye")
  end if
end procedure


-- call all the procs and funcs in the order we want em
help()
setup()
while move() = 1 do
end while
sav()


-- reset everything, back to the way it was.
clear_screen()
if graphics_mode(2) then
  puts(1, "error")
  abort(1)
end if

puts(1, "1999 Greg Phillips\ni.shoot@rednecks.com")
